<?php
class tx_multishop_payment_method extends mslib_payment {
	function displayPaymentButton($orders_id, $ref) {
		$order=mslib_fe::getOrder($orders_id);
		if ($order['orders_id']) {
			$vars=$this->variables;
			$success_url=$ref->FULL_HTTP_URL.mslib_fe::typolink($ref->shop_pid, '&tx_multishop_pi1[page_section]=psp_accepturl');
			$failed_url=$ref->FULL_HTTP_URL.mslib_fe::typolink($ref->shop_pid, '&tx_multishop_pi1[page_section]=psp_exceptionurl');
			$cancelled_url=$ref->FULL_HTTP_URL.mslib_fe::typolink($ref->shop_pid, '&tx_multishop_pi1[page_section]=psp_cancelurl');
			$transaction_id=mslib_fe::createPaymentTransactionId($order['orders_id'], 'sofort', $order['payment_method']);
			/* $hash_data = array(
					$vars['user_id'], // user_id
					$vars['project_id'], // project_id
					'', // sender_holder
					'', // sender_account_number
					'', // sender_bank_code
					'', // sender_country_id
					$order['total_amount'], // amount
					$ref->ms['MODULES']['CURRENCY_ARRAY']['cu_iso_3'], // currency_id, mandatory parameter at hash calculation
					$ref->ms['MODULES']['STORE_NAME'].' order: '.$order['orders_id'],// reason_1
					'', // reason_2
					$transaction_id, // user_variable_0
					$success_url, // user_variable_1
					$failed_url, // user_variable_2
					$cancelled_url, // user_variable_3
					'', // user_variable_4
					'', // user_variable_5
					$vars['project_password'] // project_password
			);

			$data_implode = implode('|', $hash_data);
			$hash = sha1($data_implode);

			$content .= '<form action="https://www.sofort.com/payment/start" method="POST" id="pspform" name="pspform">';
			$content .= '<input type="hidden" name="user_id" value="' . $vars['user_id'] . '" />';
			$content .= '<input type="hidden" name="project_id" value="' . $vars['project_id'] . '" />';
			$content .= '<input type="hidden" name="amount" value="' . $order['total_amount'] . '" />';
			$content .= '<input type="hidden" name="currency_id" value="' . $ref->ms['MODULES']['CURRENCY_ARRAY']['cu_iso_3'] . '" />';
			$content .= '<input type="hidden" name="reason_1" value="' . $ref->ms['MODULES']['STORE_NAME'].' order: '.$order['orders_id'] . '" />';
			$content .= '<input type="hidden" name="user_variable_0" value="' . $transaction_id . '" />'; // transaction_id
			$content .= '<input type="hidden" name="user_variable_1" value="' . $success_url . '" />'; // success_url
			$content .= '<input type="hidden" name="user_variable_2" value="' . $failed_url . '" />'; // failed_url
			$content .= '<input type="hidden" name="user_variable_3" value="' . $cancelled_url . '" />'; // cancel_url
			$content .= '<input type="hidden" name="hash" value="' . $hash . '" />';
			$content .= '<input type="submit" value="Pay with sofortbanking" />';
			$content .= '</form>'; */
			require_once(\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extPath('multishop_sofort').'res/library/sofortLib.php');
			define('CONFIGKEY', $vars['sofort_config_key']); //your configkey or userid:projektid:apikey
			$Sofort=new SofortLib_Multipay(CONFIGKEY);
			$Sofort->setSofortueberweisung();
			$Sofort->setAmount($order['total_amount'], $ref->ms['MODULES']['CURRENCY_ARRAY']['cu_iso_3']);
			$Sofort->setReason($ref->ms['MODULES']['STORE_NAME'], 'order: '.$order['orders_id']);
			//$Sofort->setSenderAccount('88888888', '12345678', 'Max Mustermann');
			$Sofort->addUserVariable($transaction_id);
			$Sofort->setSuccessUrl($success_url);
			$Sofort->setAbortUrl($cancelled_url);
			$Sofort->setTimeoutUrl($failed_url);
			$Sofort->setNotificationUrl($ref->FULL_HTTP_URL.mslib_fe::typolink($ref->shop_pid.',2002', 'tx_multishop_pi1[page_section]=psp&tx_multishop_pi1[payment_lib]=sofort&tx_multishop_pi1[payment_section]=notification', 1));
			$Sofort->sendRequest();
			if ($Sofort->isError()) {
				//PNAG-API didn't accept the data
				echo $Sofort->getError();
			} else {
				//buyer must be redirected to $paymentUrl else payment cannot be successfully completed!
				$paymentUrl=$Sofort->getPaymentUrl();
				header('Location: '.$paymentUrl);
			}
		}
		return $content;
	}
	function paymentNotificationHandler() {
		//include_once ( \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extPath('multishop_sofort').'res/library/sofortLib.php');
		$post=$this->ref->post;
		$get=$this->ref->get;
		$stream=file_get_contents('php://input');
		switch ($get['tx_multishop_pi1']['payment_section']) {
			case 'notification':
				// Array that can contain errors for merchant
				$erno=array();
				$data=array();
				// same routine as the success case
				//we don't really need a huge parser, simply extract the transaction-id
				preg_match('#<transaction>([0-9a-z-]+)</transaction>#i', $stream, $matches);
				$data['transactionId']=$matches[1];
				if (!empty($data['transactionId'])) {
					require_once(\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extPath('multishop_sofort').'res/library/sofortLib.php');
					$user_payment_methods=mslib_fe::loadPaymentMethods();
					foreach ($user_payment_methods as $user_method) {
						if ($user_method['code']=='sofort') {
							if ($user_method['vars']) {
								$vars=unserialize($user_method['vars']);
							}
						}
					}
					$sofort=new SofortLib_TransactionData($vars['sofort_config_key']);
					// or simply add a single transactionID, using addTransaction (you could easily add an array of transactionIDs as well!)
					$sofort->addTransaction($data['transactionId']);
					$sofort->sendRequest();
					$data['multishopTransactionId']=$sofort->getUserVariable(0);
					$data['sofortStatus']=$sofort->getStatus();
					$data['sofortStatusReason']=$sofort->getStatusReason();
					if ($data['multishopTransactionId']) {
						$data['ordersId']=mslib_fe::getOrdersIdByTransactionId($data['multishopTransactionId'], 'sofort');
						if ($data['ordersId'] && $data['sofortStatus']=='received' && ($data['sofortStatusReason']=='credited' || $data['sofortStatusReason']=='consumer_protection')) {
							mslib_fe::updateOrderStatusToPaid($data['ordersId']);
							if ($vars['success_status']>0) {
								mslib_befe::updateOrderStatus($data['ordersId'], $vars['success_status']);
							}
						} elseif ($data['ordersId']) {
							$erno[]='Payment status is not OK: '.$data['sofortStatus'];
						}
					} else {
						$erno[]='Multishop transaction cannot be loaded';
					}
				} else {
					$erno[]='transactionId is empty';
				}
				if (count($erno)) {
					$subject='Sofort payment IPN alert';
					$mailBody='<h3>Error(s):</h3>'."\n";
					$mailBody.=implode('<br/>'."\n", $erno);
					$mailBody.='<br/><br/>';
					$mailBody.='<h3>Parameter data</h3>';
					foreach ($data as $key=>$val) {
						$mailBody.=$key.': '.$val.'<br/>';
					}
					$mailBody.='<br/><br/>';
					$mailBody.='<h3>Raw data</h3>';
					$mailBody.='<pre>'.print_r($matches, 1).'</pre><br/><br/>';
					if (is_object($sofort)) {
						$mailBody.='<h4>Sofort</h4><pre>'.print_r($sofort, 1).'</pre><br/><br/>'."\n";
					}
					$mailBody.='<br/>';
					$mailBody.='<h4>Stream</h4><pre>'.print_r($stream, 1).'</pre>';
					$mailBody.='<br/>';
					$user=array();
					$user['name']=$this->ref->ms['MODULES']['STORE_NAME'];
					$user['email']=$this->ref->ms['MODULES']['STORE_EMAIL'];
					mslib_fe::mailUser($user, $subject, $mailBody, $this->ref->ms['MODULES']['STORE_EMAIL'], $this->ref->ms['MODULES']['STORE_NAME']);
				}
				break;
		}
	}
}
?>